fieldOfView = 45

Z0 = (love.graphics.getWidth() / 2) / math.tan((fieldOfView / 2) * math.pi / 180)

function newPoint(x, y, z, u, v)

    local point = {}
    point.x = x
    point.y = y
    point.z = z
	point.u = u
	point.v = v
    return point

end

function newTriangle(p1, p2, p3, tex)

    local points = {}
    points[1] = p1
    points[2] = p2
    points[3] = p3
	points.texture = tex
    return points

end

function translate(original, translation)

	local toReturn = {}
	toReturn.x = original.x + translation.x
	toReturn.y = original.y + translation.y
	toReturn.z = original.z + translation.z
	toReturn.u = original.u
	toReturn.v = original.v
	return toReturn

end

function rotate(original, rotation)

	local toReturn = {}
	toReturn.x = original.x * (math.cos(rotation.z) * math.cos(rotation.y)) + original.y * (math.cos(rotation.z) * math.sin(rotation.y) * math.sin(rotation.x) - math.sin(rotation.z) * math.cos(rotation.x)) + original.z * (math.cos(rotation.z) * math.sin(rotation.y) * math.cos(rotation.x) + math.sin(rotation.z) * math.sin(rotation.x))
	toReturn.y = original.x * (math.sin(rotation.z) * math.cos(rotation.y)) + original.y * (math.sin(rotation.z) * math.sin(rotation.y) * math.sin(rotation.x) + math.cos(rotation.z) * math.cos(rotation.x)) + original.z * (math.sin(rotation.z) * math.sin(rotation.y) * math.cos(rotation.x) - math.cos(rotation.z) * math.sin(rotation.x))
	toReturn.z = original.x * (- math.sin(rotation.y)) + original.y * (math.cos(rotation.y) * math.sin(rotation.x)) + original.z * (math.cos(rotation.y) * math.cos(rotation.x))
	toReturn.u = original.u
	toReturn.v = original.v
	return toReturn

end

function applyPerspective(original)

	local toReturn = {}
	toReturn.x = original.x * Z0 / (Z0 + original.z)
	toReturn.y = original.y * Z0 / (Z0 + original.z)
	toReturn.z = original.z
	toReturn.u = original.u
	toReturn.v = original.v
	return toReturn

end

function centerScreen(original)

	local toReturn = {}
	toReturn.x = original.x + love.graphics.getWidth() / 2
	toReturn.y = original.y + love.graphics.getHeight() / 2
	toReturn.z = original.z
	toReturn.u = original.u
	toReturn.v = original.v
	return toReturn

end

