require('cube')
noTriangles = 12
rotationSpeed = 1
drawPoints = {}
worldPoints = {}
allTriangles = {}

function triangleUpdates(dt)

    rotationPoint.y = rotationPoint.y + (rotationSpeed * dt)

    for t = 1, noTriangles do
        processingPoints(triangles[t])
        allTriangles[t] = {worldPoints, averageZ}
        worldPoints = {}
    end

    table.sort(allTriangles, triangleSort)

end

function processingPoints(triangles)

    for i = 1, 3 do
        worldPoints[i] = rotate(triangles[i], rotationPoint)
    end

    for i = 1, 3 do
        worldPoints[i] = translate(worldPoints[i], positionPoint)
    end

    worldPoints.texture = triangles.texture

    averageZ = (worldPoints[1].z + worldPoints[2].z + worldPoints[3].z) / 3
    
end

function drawTriangles()

    for t = 1, noTriangles do
        drawPolygons(allTriangles[t][1])
    end

end

function drawPolygons(worldPoints)

    for i = 1, 3 do
        drawPoints[i] = applyPerspective(worldPoints[i])
    end
    
    for i = 1, 3 do
        drawPoints[i] = centerScreen(drawPoints[i])
    end

    drawPoints.texture = worldPoints.texture

    normalZ = (drawPoints[2].x - drawPoints[1].x) * (drawPoints[3].y - drawPoints[1].y) - (drawPoints[2].y - drawPoints[1].y) * (drawPoints[3].x - drawPoints[1].x)

    mesh = createMesh(drawPoints)

    if normalZ < 0 then
        love.graphics.draw(mesh)
    end

end

function triangleSort(triangle1, triangle2)

    return triangle1[2] > triangle2[2]

end

function createMesh(points)

    local vertices = {}
    vertices[1] = {points[1].x, points[1].y, points[1].u, points[1].v}
    vertices[2] = {points[2].x, points[2].y, points[2].u, points[2].v}
    vertices[3] = {points[3].x, points[3].y, points[3].u, points[3].v}

    local mesh = love.graphics.newMesh(vertices, "fan")
    mesh:setTexture(points.texture)

    return mesh

end

